/****************************************************************************
* Program name  : FANDAI2313.C
* Descriptions  : DCt@ŉ]
* Micro computer: AVR Tiny2313 @RCU8MHz
* note          : GCC -Os ŃRpC
* Date          : 2009.03.07
* Author        : ł񂵌 TAD  http://homepage2.nifty.com/denshiken/
* E-mail        : denshihken@pc.nifty.jp
****************************************************************************/
/* e
*
* DCt@(12V)~jtBMẢ]ƂĎg߂̃\tg
*
* 1.3`1.8b45x񂷁B
* 5VPWMo͂ŉ]鋭𒲐B
* PWM3.9kHz(sb)31kHz()2ށB
* ]鋭PWMgEE-PROMɋLB
*
*  ˂ǂ낢 Ղ(nq)ŒllɂB
*/

// 2009.10.10 Ver1.1 ̗͂ア̂PWM_MAX3062ɕύXBtoneʂpwmlLB
// 2008.03.07 Ver1.0 ō쐬

#include <avr/io.h>

#define nop() __asm__ __volatile__ ("nop")

/***************************************************************************/
/* 萔̒`                                                              */
/***************************************************************************/
// I/O̒`
#define PWM_MAX		62							// PWMől fan_*_tone();ł̉Zlɒ
#define INC_PB		0x80						// ] {t
#define DEC_PB		0x40						// ] |t
#define TONE_PB		0x02			 			// PWM؂芷t

#define TONE_ADRS	1							// tonelEE-PROMAhX
#define PWM_ADRS	2							// pwmlEE-PROMAhX toneʂpwml
//#define PWM_ADor1	3							// pwmlEE-PROMAhX toneʂpwml

#define PWM_OFFSET	10							// ̒l(0xFF)PWMWl(10)ɂ

/***************************************************************************/
/* O[oϐ                                                          */
/***************************************************************************/
uint8_t		sw;									// XCb`
uint8_t		pwm;								// PWM䗦
uint8_t		tone;								// PWMg̎


/****************************************************************************/
/* `bvݒ                                                           */
/****************************************************************************/
void ChipInit(void)
{
	CLKPR = _BV(CLKPCE);						// ݒ
	CLKPR = 0;									// 8MHzɐݒ

	// |-----|-----|-----|-----|-----|-----|-----|-----|
	// | --- | --- | --- | --- | --- | PA2 | PA1 | PA0 |
	// | xxx | xxx | xxx | xxx | xxx |(RST)| --- | --- |
	// |-----|-----|-----|-----|-----|-----|-----|-----|
	// | PB7 | PB6 | PB5 | PB4 | PB3 | PB2 | PB1 | PB0 |
	// |incPB|decPB| (MO)| --- | --- | PWM |tonPB| --- |
	// |-----|-----|-----|-----|-----|-----|-----|-----|
	// | --- | PD6 | PD5 | PD4 | PD3 | PD2 | PD1 | PD0 |
	// | xxx | --- | --- | --- | --- | --- |(TXD)|(RXD)|
	// |-----|-----|-----|-----|-----|-----|-----|-----|

	PORTA = 0x07;
	DDRA  = 0x00;

	PORTB = 0xFB;								// PWMo͈ȊO̓vAbv
	DDRB  = 0x04;

	PORTD = 0x7F;
	DDRD  = 0x00;

	ACSR   = _BV(ACD);							// analogue comp power off
}

/****************************************************************************/
/* \tg^C}[ 10ubP                                                 */
/****************************************************************************/
void tr10us(unsigned char i)					// 10uSP
{
	unsigned char  j;

	i -= 8;										// 傢Ԓ

	for( ; 0<i; i--)
		for(j=1; j<=16; j++)					// RpC̍œKɈˑ
			nop();
}

/****************************************************************************/
/* \tg^C}[ 1mbP                                                  */
/****************************************************************************/
void tr1ms(unsigned char i)						// 1mSP
{
	for( ; 0<i; i--){
		tr10us(100);
	}
}

/****************************************************************************/
/* \tg^C}[ 0.1bP                                                 */
/****************************************************************************/
void tr01s(unsigned char i)						// 0.1SP
{
	for( ; 0<i; i--){
		tr1ms(100);
		sw &= PINB;								// XCb`͂̋L
	}
}

/****************************************************************************/
/* pwmlEE-PROMǂݏo                                               */
/****************************************************************************/
void load_pwm(void)
{
	while(EECR & (1<<EEPE))						// ҂
		;

	EEAR = PWM_ADRS |(tone & 0x01);				// AhX toneʂpwml
	EECR |= (1<<EERE);							// ǂݏoJn
	pwm = EEDR + (PWM_OFFSET +1);				// ̒l(0xFF)PWMWlɂ
}
/****************************************************************************/
/* PWMg̎ނEE-PROMǂݏo                                     */
/****************************************************************************/
void load_tone(void)
{
	while(EECR & (1<<EEPE))						// ҂
		;

	EEAR = TONE_ADRS;							// AhX
	EECR |= (1<<EERE);							// ǂݏoJn
	tone = EEDR;
}
/****************************************************************************/
/* pwmlEE-PROMɕۑ                                                     */
/****************************************************************************/
void save_pwm(void)
{
	while(EECR & (1<<EEPE))						// ҂
		;

	EECR = (0<<EEPM1)|(0<<EEPM0);				// ʐݒ
	EEAR = PWM_ADRS |(tone & 0x01);				// AhX toneʂpwml
	EEDR = pwm - (PWM_OFFSET +1);				// ̒l(0xFF)PWMWlɂ
	EECR |= (1<<EEMPE);							// }X^[
	EECR |= (1<<EEPE);							// vOJn
}
/****************************************************************************/
/* PWMg̎ނEE-PROMɕۑ                                           */
/****************************************************************************/
void save_tone(void)
{
	while(EECR & (1<<EEPE))						// ҂
		;

	EECR = (0<<EEPM1)|(0<<EEPM0);				// ʐݒ
	EEAR = TONE_ADRS;							// AhX
	EEDR = tone;
	EECR |= (1<<EEMPE);							// }X^[
	EECR |= (1<<EEPE);							// vOJn
}

/****************************************************************************/
/* t@](sb)                                                       */
/****************************************************************************/
void fan_with_tone(void)
{
	uint8_t  i;									// łPWM䗦

	TCCR0A = _BV(COM0A1)|_BV(WGM01)|_BV(WGM00); // 8bitPWM vL
	TCCR0B = _BV(CS01);							// 8bitPWM 8(3.9kHz)sb

	i  = pwm << 1;								// pwm*2 (pwm̕W10)
	i += 80;									// 100
	OCR0A=i;  tr1ms(60);  i+= 50;				// 100 ͂
	OCR0A=i;  tr1ms(60);  						// 150

	OCR0A=255;									// 100Ŏԏo
	tr1ms(pwm+22);								//  32ms

	TCCR0A =  0;								// Timer0 ~
	tr01s(12);
}

/****************************************************************************/
/* t@]()                                                       */
/****************************************************************************/
void fan_no_tone(void)
{
	uint8_t  i;									// łPWM䗦

	TCCR0A = _BV(COM0A1)|_BV(WGM01)|_BV(WGM00); // 8bitPWM vL
	TCCR0B = _BV(CS00);							// 8bitPWM 1/1(31kHz)

	i = pwm;
	OCR0A=i;  tr1ms(10);  i+= 5;				// 10 Xɗ͂Ă
	OCR0A=i;  tr1ms(10);  i+= 5;				// 15
	OCR0A=i;  tr1ms(10);  i+= 5;				// 20
	OCR0A=i;  tr1ms(10);  i+= 5;				// 25
	OCR0A=i;  tr1ms(10);  i+= 5;				// 30
	OCR0A=i;  tr1ms(10);  i+= 5;				// 35
	OCR0A=i;  tr1ms(10);  i+=10;				// 40
	OCR0A=i;  tr1ms(10);  						// 50

	OCR0A=255;									// 100Ŏԏo
	tr1ms(pwm+10);								//  20ms

	TCCR0A =  0;								// Timer0 ~
	tr01s(15);
}

/****************************************************************************/
/* C                                                                   */
/****************************************************************************/
int main (void)
{
	ChipInit();
	load_pwm();							// pwmlEE-PROMǂݏo
	load_tone();						// PWMg̓ǂݏo

	while(1){
		sw = 0xFF;						// XCb` NA
										// tr01s()ŃXCb`ONƊYbitOFF
		if(tone & 0x01)
			 fan_with_tone();			// sbŃt@]
		else fan_no_tone();				// Ńt@]

		sw = ~sw;						// ON1ɕϊ

		if(sw & INC_PB){				// ] {t
			if(pwm < PWM_MAX){
				pwm++;
				save_pwm();				// pwmlL
				tr01s(2);				// t OFF҂(swNÃ^C~OɂĂQ++Ƃ邩)
			}
		}
		if(sw & DEC_PB){				// ] |t
			if(pwm > 0){
				pwm--;
				save_pwm();				// pwmlL
				tr01s(2);				// t OFF҂
			}
		}
		if(sw & TONE_PB){				// PWM؂芷t
			tone++;
			save_tone();				// PWMg̋L
			tr01s(2);					// t OFF҂
			load_pwm();					// toneʂpwml̂œǂݒ
		}
	}
}

/**** End of File ****/
